<script lang="ts">
  import dedent from "dedent-js"
  import Prism from "svelte-prism"

  import { browser } from "$app/environment"
  import { goto } from "$app/navigation"
  import { page } from "$app/stores"
  import type { Access } from "$lib/access"
  import type { Departement } from "$lib/code_officiel_geographique"
  import ErrorAlert from "$lib/components/errors/ErrorAlert.svelte"
  import JsonTree from "$lib/components/JsonTree.svelte"
  import type { DepartementSuggestion } from "$lib/suggestions"

  import type { PageData } from "./$types"

  export let data: PageData

  let init = true
  const { url } = $page
  const { searchParams } = url
  const fields = searchParams.getAll("field")
  let departementField = fields.includes("departement")
  let q = searchParams.get("q") ?? ""

  $: ({ error, suggestions } = data)

  $: handleChange(q, departementField)

  $: sourceCode = dedent`
      const response = await fetch(
        ${JSON.stringify(new URL(url.pathname, url.origin))} +
          ${JSON.stringify("?" + searchFromParams(q, departementField))},
        { headers: { Accept: "application/json" } }
      );
      const { suggestions } = await response.json();
    `

  async function handleChange(
    q: string,
    departementField: boolean,
  ): Promise<void> {
    if (browser) {
      if (init) {
        init = false
      } else {
        const search = searchFromParams(q, departementField)
        await goto(`${url.pathname}${search ? "?" + search : ""}`, {
          keepFocus: true,
          noScroll: true,
        })
      }
    }
  }

  function searchFromParams(q: string, departementField: boolean): string {
    return new URLSearchParams(
      [
        ["q", q ?? undefined],
        ["field", departementField ? "departement" : undefined],
      ].filter(([, value]) => value !== undefined) as Array<[string, string]>,
    ).toString()
  }

  function summarize(
    access: Access | undefined,
    value: unknown,
  ): string | undefined {
    if (access === undefined) {
      return undefined
    } else if (access.access === undefined) {
      const suggestion = value as DepartementSuggestion
      return suggestion.role === undefined
        ? suggestion.autocompletion
        : `${suggestion.autocompletion} (${suggestion.libelle})`
    } else if (access.key === "departement") {
      const departement = value as Departement
      return `${departement.DEP} (${departement.LIBELLE})`
    } else {
      return undefined
    }
  }
</script>

<header class="prose my-6 max-w-full">
  <h1>Service de suggestion de départements (DGCL)</h1>
</header>

{#if error != null}
  <ErrorAlert {error} />
{/if}

<form class="mx-auto max-w-lg" on:submit|preventDefault>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text">Département</span>
      <input
        class="input-bordered input w-full max-w-xs"
        type="text"
        placeholder="Nom ou numéro du département"
        bind:value={q}
      />
    </label>
  </div>
  <div class="form-control">
    <label class="label cursor-pointer">
      <span class="label-text">Informations sur le département</span>
      <input bind:checked={departementField} class="checkbox" type="checkbox" />
    </label>
  </div>
</form>

<section>
  <header class="prose my-4 max-w-full">
    <h2>Requête</h2>
  </header>

  <div>
    <Prism language="javascript" source={sourceCode} />
  </div>
</section>

{#if error == null}
  <section>
    <header class="prose my-4 max-w-full">
      <h2>Suggestions</h2>
    </header>

    {#if !suggestions?.length}
      <p><i>Aucune suggestion</i></p>
    {:else}
      <div>
        <JsonTree frame={false} open {summarize} value={suggestions} />
      </div>
    {/if}
  </section>
{/if}
